import static org.valid4j.Assertive.*;


public class Evaluator {

    private float counter;

    public void setCounter(float counter) {
        this.counter = counter;
    }


    public float visit(AstExpression node) {

        if(node.astExpression != null) {

            return visit(node.astExpression);

        } else if(node.astBinaryOp != null) {

            return visit(node.astBinaryOp);

        } else {

            return visit(node.astValue);

        }

    }

    public float visit(AstBinaryOp node) {


        //visit(node.astExpression1);

        switch(node.astOperator.astOperatorContent) {

            case "+":
                return visit(node.astExpression1) + visit(node.astExpression2);
            case "-":
                return visit(node.astExpression1) - visit(node.astExpression2);
            case "*":
                return visit(node.astExpression1) * visit(node.astExpression2);
            case "/":
                return visit(node.astExpression1) / visit(node.astExpression2);
            case "^":
                return (float) Math.pow(visit(node.astExpression1), visit(node.astExpression2));
        }

        neverGetHere();
        return -111;
    }

    // AstExpression = ( (5 + 5.5) + x )
    // a) visit( (5 + 5.5) ) = 5 + 5.5
    // b)
    // c)
    public float visit(AstValue node) {

        if(node.astVariable != null) {

            return visit(node.astVariable);

        } else if (node.astNumber != null){

            return visit(node.astNumber);

        } else {

            return Float.parseFloat(visit(node.astDecimal.astDigitBeforeComma)
                    + "."
                    + visit(node.astDecimal.astDigitAfterComma));
        }
    }

    public int visit(AstNumber node) {

        return node.astDigitWoz.astDigitWozContent;

    }

    public float visit(AstVariable node) {

        return counter;

    }

}
